/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0/Kx2
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2008
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0/Kx2 V2.10 [6 Mar. 2007]
**
**  Device :	uPD78F0515_48
**
**  Compiler :	CC78K0
**
**  Creation date:	2008/07/27
**  
*******************************************************************************
*/

/*
*******************************************************************************
** Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "System.h"
#include "Port.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**-----------------------------------------------------------------------------
*/
unsigned int	khz_no;

const unsigned int	a[123]={
		524,568,612,655,699,743,777,812,847,884,
		921,958,995,1033,1070,1107,1144,1182,1219,1256,
		1282,1307,1333,1358,1384,1409,1437,1465,1493,1521, 
		1549,1578,1606,1627,1649,1673,1696,1719,1742,1753, 
		1779,1804,1830,1843,1857,1871,1884,1898,1911,1937, 
		1962,1988,2013,2039,2064,2074,2084,2094,2104,2114, 
		2140,2166,2192,2218,2244,2270,2296,2322,2348,2366, 
		2383,2401,2418,2436,2458,2481,2504,2526,2549,2572, 
		2594,2615,2635,2656,2676,2697,2717,2737,2758,2775, 
		2793,2810,2827,2844,2862,2879,2896,2914,2931,2948, 
		2966,2982,2999,3016,3033,3050,3067,3084,3101,3118, 
		3135,3170,3206,3223,3240,3257,3274,3290,3307,3324, 
		3341,3358,3375 };


void	init_data(void)
{
	khz_no=58;
	P7.3=1;P7.4=1;P7.5=0;
}

void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}
/*----------  LCD MODULE ----------*/
void	lcd_db(unsigned char data)
{
	P2.0=data&0x01;
	P2.1=(data&0x02)>>1;
	P2.2=(data&0x04)>>2;
	P2.3=(data&0x08)>>3;
}
void	lcd_wait(void)
{
	wait_time(5000);
}
void	lcd_c_set(void)
{
	P13.0=0;
	P14.0=1;
	wait_time(10);
	P14.0=0;
}
void	lcd_d_set(void)
{
	P13.0=1;
	P14.0=1;
	wait_time(10);
	P14.0=0;
}
void	lcd_cmd(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_c_set();
	lcd_db(data&0x0f);
	lcd_c_set();
	wait_time(500);
}
void	lcd_data(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_d_set();
	lcd_db(data&0x0f);
	lcd_d_set();
	wait_time(500);
}
void	lcd_init(void)
{
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(2);
	lcd_c_set();
	lcd_wait();
	
	lcd_cmd(0x28);
	lcd_cmd(0x08);
	lcd_cmd(0x0c);
	lcd_cmd(0x06);
}
void	lcd_clear(void)
{
	lcd_cmd(0x01);
}
void	lcd_xy(unsigned char x,unsigned char y)
{
unsigned char data;

	data=0x80;
	switch (y){
		case 0:data=0x80;break;
		case 1:data=0xc0;break;
		case 2:data=0x90;break;
		case 3:data=0xd0;break;
	}
	data=data+x;
	lcd_cmd(data);
}
void	lcd_print(char *data)
{
	while (*data!=0){
		lcd_data(*data++);
	}
}
void	lcd_su(unsigned char data)
{
	switch (data){
		case 0:lcd_print("0");break;
		case 1:lcd_print("1");break;
		case 2:lcd_print("2");break;
		case 3:lcd_print("3");break;
		case 4:lcd_print("4");break;
		case 5:lcd_print("5");break;
		case 6:lcd_print("6");break;
		case 7:lcd_print("7");break;
		case 8:lcd_print("8");break;
		case 9:lcd_print("9");break;
		case 10:lcd_print("A");break;
		case 11:lcd_print("B");break;
		case 12:lcd_print("C");break;
		case 13:lcd_print("D");break;
		case 14:lcd_print("E");break;
		case 15:lcd_print("F");break;
	}
}
void	lcd_khz(unsigned int hz)
{
unsigned char n0,n1,n2,n3;
unsigned int count;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);

	if(n3==0){lcd_print(" ");}else{lcd_su(n3);}
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
	
}
void	lcd_pr_byte(unsigned char data)
{
unsigned char data2;

	data2=data%16;data=data/16;
	lcd_su(data);
	lcd_su(data2);
}
void	lcd_ini_disp(void)
{
	lcd_xy(1,0);
	lcd_print("    kHz");

}
void	lcd_2keta10(unsigned char count)
{
unsigned char n0,n1;

	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);

	lcd_su(n1);
	lcd_su(n0);
}
void	lcd_4keta10(unsigned int count)
{
unsigned char n0,n1,n2,n3;

	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);

	lcd_su(n3);
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
}
/*---------- VOLTAGE  ----------*/
void	dac_out_ch1(unsigned int data)
{
unsigned int 	d0;
unsigned char	i;

	P7.4=0;
	P7.3=1;
	d0=data | 0x8000;
	
	for(i=0;i<16;i++){
		if((d0 & 0x8000)==0x8000){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=0;
		d0=d0 << 1;
		P7.3=1;
	}
	P7.4=1;
	P7.5=0;
}
void	vol_out(unsigned int volt)
{
	dac_out_ch1(volt);		/* DAC CH 1 */
}
/*----------  KHZ    ----------*/
void	khz_inc(void)
{
	khz_no++;
	if(khz_no==181){khz_no=58;}
}

void	khz_dec(void)
{
	khz_no--;
	if(khz_no==57){khz_no=180;}
}
void	khz_inc_10(void)
{
	khz_no=khz_no+10;
	if(khz_no>=181){khz_no=58;}
}

void	khz_dec_10(void)
{
	khz_no=khz_no-10;
	if(khz_no<=57){khz_no=180;}
}

void	khz_set(void)
{
	vol_out(a[khz_no-58]);
}
/*---------- PRESET ---------*/
void	kyokumei(unsigned int no)
{
	lcd_xy(1,1);
	switch(no){
		case 62:lcd_print("KANSAI ");break;
		case 63:lcd_print("NHK1   ");break;
		case 66:lcd_print("NHK1   ");break;
		case 68:lcd_print("NHK1   ");break;
		case 69:lcd_print("NHK1   ");break;
		case 74:lcd_print("NHK1   ");break;
		case 76:lcd_print("IBC    ");break;
		case 77:lcd_print("NHK2   ");break;
		case 81:lcd_print("NHK1   ");break;
		case 82:lcd_print("KNB    ");break;
		case 83:lcd_print("NHK2   ");break;
		case 85:lcd_print("YBS/KRY");break;
		case 86:lcd_print("NHK2   ");break;
		case 90:lcd_print("AFN    ");break;
		case 92:lcd_print("NHK2   ");break;
		case 93:lcd_print("NHK1   ");break;
		case 94:lcd_print("NHK1   ");break;
		case 96:lcd_print("FBC    ");break;
		case 97:lcd_print("NHK2   ");break;
		case 99:lcd_print("NHK1   ");break;
		case 100:lcd_print("BSS/RKC");break;
		case 102:lcd_print("YBC    ");break;
		case 103:lcd_print("NHK1   ");break;
		case 104:lcd_print("ABS/MRT");break;
		case 106:lcd_print("TBS    ");break;
		case 112:lcd_print("ABC    ");break;
		case 114:lcd_print("NHK1   ");break;
		case 117:lcd_print("CBC    ");break;
		case 121:lcd_print("NHK2   ");break;
		case 122:lcd_print("SBC/OBS");break;
		case 123:lcd_print("MBC/MRO");break;
		case 124:lcd_print("BSN/RNB");break;
		case 125:lcd_print("NHK2   ");break;
		case 126:lcd_print("BUNKA  ");break;
		case 127:lcd_print("KBS    ");break;
		case 131:lcd_print("MBS    ");break;
		case 133:lcd_print("RKK/IBS");break;
		case 136:lcd_print("NHK1   ");break;
		case 137:lcd_print("RAB/NBC");break;
		case 138:lcd_print("NIPPON ");break;
		case 140:lcd_print("TBC    ");break;
		case 141:lcd_print("JRT    ");break;
		case 142:lcd_print("RKB    ");break;
		case 143:lcd_print("HBC    ");break;
		case 146:lcd_print("OBC    ");break;
		case 148:lcd_print("TOKAI  ");break;
		case 150:lcd_print("RCC    ");break;
		case 154:lcd_print("NHK1/2 ");break;
		case 156:lcd_print("SBS    ");break;
		case 157:lcd_print("KBC    ");break;
		case 158:lcd_print("RNIPPON");break;
		case 159:lcd_print("GBS/WBS");break;
		case 160:lcd_print("STV    ");break;
		case 161:lcd_print("RNC    ");break;
		case 162:lcd_print("RFC/NBC");break;
		case 166:lcd_print("RSK    ");break;
		case 168:lcd_print("NHK2   ");break;
		case 170:lcd_print("CRT    ");break;
		case 173:lcd_print("FBC    ");break;
		default:lcd_print("       ");break;
	}
}
/*---------- MAIN -----------*/
void  main( void )
{
unsigned int	freq_khz;
unsigned char	up_key;
unsigned char	up_rep;
unsigned char	up_cnt;
unsigned char	down_key;
unsigned char	down_rep;
unsigned char	down_cnt;


	init_data();

	up_key=0;up_rep=0;
	down_key=0;down_rep=0;
	up_cnt=0;down_cnt=0;
	
	lcd_init();
	lcd_clear();
	lcd_ini_disp();

	khz_set();
	lcd_xy(1,0);
	lcd_khz(khz_no*9);
	

	/* Start user code. Do not edit comment generated here */
	while (1) {
	/* key scan 1 */
		if (P1.0==0){
				up_key=0;
		}
		else{
			up_key=1;
			up_rep=0;
			up_cnt=0;
		}
		/*------------------*/
		if (P1.1==0){
				down_key=0;
		}
		else{
			down_key=1;
			down_rep=0;
			down_cnt=0;
		}
		/*------------------*/


		/*-------------------*/
		
		wait_time(2000);

		/*-------------------*/

	/* key scan 2 */
		if ((P1.0==0)&(up_key==0)){
			up_key=0;
		}
		else{
			up_key=1;
			up_rep=0;
			up_cnt=0;
		}
		/*------------------*/
		if ((P1.1==0)&(down_key==0)){
			down_key=0;
		}
		else{
			down_key=1;
			down_rep=0;
			down_cnt=0;
		}
		/*------------------*/


	/* key action */
	
		if((up_key==0)&(up_rep==0)){
			up_rep=1;
			khz_inc();
			khz_set();
			lcd_xy(1,0);
			lcd_khz(khz_no*9);
			kyokumei(khz_no);
		}
		if((up_key==0)&(up_rep==1)){
			up_cnt++;
			if(up_cnt>=50){
				khz_inc_10();
				khz_set();
				lcd_xy(1,0);
				lcd_khz(khz_no*9);
				kyokumei(khz_no);
				up_cnt=0;
			}
		}
		/*------------------*/
		if((down_key==0)&(down_rep==0)){
			down_rep=1;
			khz_dec();
			khz_set();
			lcd_xy(1,0);
			lcd_khz(khz_no*9);
			kyokumei(khz_no);
		}
		if((down_key==0)&(down_rep==1)){
			down_cnt++;
			if(down_cnt>=50){
				khz_dec_10();
				khz_set();
				lcd_xy(1,0);
				lcd_khz(khz_no*9);
				kyokumei(khz_no);
				down_cnt=0;
			}
		}
		/*------------------*/
	}

	/* End user code. Do not edit comment generated here */
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */


